wgee=function(eps=1e-6,ini=NULL,kmax=50,corstr=NULL,LORstr=NULL,assoc.type=NULL,data=NULL)
{
W=aux.weight$W;W.rho=aux.weight$W.rho;S.psi=aux.weight$S.psi;S.psi.vcov=aux.weight$S.psi.vcov
if(assoc.type=="odds"){
	LOR.aux=fitLORterm(data=data,LORstr=LORstr);
	LORterm=LOR.aux$LORterm;odds.est=LOR.aux$theta
	}
ncatm1=max(data$Y,na.rm=TRUE)-1
n.par=length(ini)
calpha=cbind(ini[1:ncatm1]);cbeta=cbind(ini[-(1:ncatm1)])
#		
est=ini;names(est)=c("beta01","beta02","X","Z")
n=length(unique(data$id))
diffe=99;
k=0
index2=rep(1:n,each=6)
H=arrange(as.data.frame(rbind(data,data)),id,time)
H.z=H$Z;H.x=H$X;H.y=H$Y;
H.y[is.na(H.y)]=0;H.x[is.na(H.x)]=0

Y1=1*I(H.y==rep(c(1,2),length(H.y)/2))

while(I(diffe>eps)+I(kmax>k)==2)
{
	### Begin of matrix of derivatives D
	alpha1=calpha[1];alpha2=calpha[2];
	Xbeta=H.x*cbeta[1]+H.z*cbeta[2]
	# Cummulative logits
	mu=plogis(rep(c(calpha[1],calpha[2]),length(H.y)/2)+Xbeta)
	idx1=seq(1,length(mu),by=2);idx2=seq(2,length(mu),by=2)
	mu[idx2]=mu[idx2]-mu[idx1]
	#
	nucleo=exp(rep(c(calpha[1],calpha[2]),length(H.y)/2)+Xbeta)/(1+exp(rep(c(calpha[1],calpha[2]),length(H.y)/2)+Xbeta))^2
	#derivative with respect to alpha
	d.alpha=t(rbind(rep(c(1,0),length(H.y)/2)*nucleo,rep(c(0,1),length(H.y)/2)*nucleo))
	d.alpha[idx2,]=d.alpha[idx2,]-d.alpha[idx1,]
	#derivative with respect to betas
	d.betas=cbind(H.x,H.z)*nucleo
	d.betas[idx2,]=d.betas[idx2,]-d.betas[idx1,]
	#
	D=as.matrix(rbind(t(d.alpha),t(d.betas)))
	### End of matrix of derivatives D
	
	### Begin calculation of V
	if(assoc.type=="corr")
	{
		# corstr=corstr
		rho.est=rho.weight(Y1=Y1,mu=mu,corstr=corstr,W.rho=W.rho,data=data)
		if(any(abs(rho.est)>1)) {rho.est=NA}
		Vinv=gencov.corr.wgee(mu=mu,rho.est=rho.est,W=W,data=data)
	}else
	if(assoc.type=="odds")
	{
		Vinv=gencov.odds.wgee(mu=mu,LORterm=LORterm,W=W,data=data)
	}
	### End calculation of V
	
	est.ant=est
	###
	DVD=matrix(0,n.par,n.par);for(i in 1:n){a=which(index2==i);DVD=DVD+D[,a]%*%(Vinv[a,a])%*%t(D[,a])}
	DVD.inv=ginv(DVD)

	S.aux=matrix(0,n.par,1);for(i in 1:n){a=which(index2==i);S.aux=S.aux+D[,a]%*%Vinv[a,a]%*%(Y1[a]-mu[a])}
	est=est+DVD.inv%*%(S.aux)
	diffe=max(abs((est-est.ant)/(est+1.e-6)))
	k=k+1
calpha=cbind(est[1:ncatm1])
cbeta=cbind(est[-(1:ncatm1)])
}
est=as.numeric(est)


#Calculation of Asymptotic Variance!
bread=DVD.inv;S.betas=matrix(NA,n,n.par)
for(i in 1:n)
{
	a=which(index2==i)
	S.betas[i,]=D[,a]%*%Vinv[a,a]%*%(Y1[a]-mu[a])
}
G=matrix(NA,n,4)
for(i in 1:n){G[i,]=S.betas[i,]-crossprod(S.betas,S.psi)%*%solve(crossprod(S.psi))%*%S.psi[i,]}
std=sqrt(diag(bread%*%crossprod(G)%*%bread))
#
# cat("wgee",":",k,"\n")
names(est)=names(std)=c("beta01","beta02","X","Z")
if(assoc.type=="odds"){return(list(est=est,std=std,k=k,odds.est=odds.est))}else
if(assoc.type=="corr"){return(list(est=est,std=std,k=k,rho.est=rho.est))}
}
