drgee=function(eps=1e-6,ini=NULL,kmax=50,corstr=NULL,LORstr=NULL,assoc.type=NULL,data=NULL)
{
W=aux.weight$W;W.rho=aux.weight$W.rho;S.psi=aux.weight$S.psi;S.psi.vcov=aux.weight$S.psi.vcov
if(assoc.type=="odds"){
	LOR.aux=fitLORterm(data=data,LORstr=LORstr);
	LORterm=LOR.aux$LORterm;odds.est=LOR.aux$theta
	}
ncatm1=max(data$Y,na.rm=TRUE)-1
n.par=length(ini)
calpha=cbind(ini[1:ncatm1]);cbeta=cbind(ini[-(1:ncatm1)])
#
est=ini;names(est)=c("beta01","beta02","X","Z")
n=length(unique(data$id))
diffe=99
k=0;#K=dim(data)[1]
index2=rep(1:n,each=6)
H=aux.cond;S.gamma=aux.cond$S.gamma;S.gamma.vcov=aux.cond$S.gamma.vcov
H.z=arrange(as.data.frame(rbind(H$Z,H$Z)),id,time)[,-c(1,2)]
H.x=arrange(as.data.frame(rbind(H$X,H$X)),id,time)[,-c(1,2)]
H.y=arrange(as.data.frame(rbind(H$Y,H$Y)),id,time)[,-c(1,2)]
D.p=arrange(as.data.frame(rbind(H$D.p,H$D.p)),id,time)[,-c(1,2)]
mm=ncol(H.x)

Y1=list(); for(l in 1:mm){Y1[[l]]=1*I(H.y[,l]==rep(c(1,2),nrow(H.y)/2))}

while(I(diffe>eps)+I(kmax>k)==2)
{
	### Begin of matrix of derivatives D
	alpha1=calpha[1];alpha2=calpha[2];
	Xbeta=list(); for(l in 1:mm){Xbeta[[l]]=H.x[,l]*cbeta[1]+H.z[,l]*cbeta[2]}
	# Cummulative logits
	mu=list();	for(l in 1:mm){mu[[l]]=plogis(rep(c(calpha[1],calpha[2]),nrow(H.y)/2)+Xbeta[[l]])}
	idx1=seq(1,length(mu[[1]]),by=2);idx2=seq(2,length(mu[[1]]),by=2)
	for(l in 1:mm){mu[[l]][idx2]=mu[[l]][idx2]-mu[[l]][idx1]}
	#
	nucleo=list();for(l in 1:mm){nucleo[[l]]=
	exp(rep(c(calpha[1],calpha[2]),nrow(H.y)/2)+Xbeta[[l]])/(1+exp(rep(c(calpha[1],calpha[2]),nrow(H.y)/2)+Xbeta[[l]]))^2}
	#derivative with respect to alpha
	d.alpha=list();	for(l in 1:mm){d.alpha[[l]]=rbind(rep(c(1,0),nrow(H.y)/2)*nucleo[[l]],rep(c(0,1),nrow(H.y)/2)*nucleo[[l]])}
	#derivative with respect to betas
	d.betas=list(); for(l in 1:mm){d.betas[[l]]=t(cbind(H.x[[l]],H.z[[l]])*nucleo[[l]])}
	#
	D=list(); for(l in 1:mm){D[[l]]=as.matrix(rbind(d.alpha[[l]],d.betas[[l]]))}
	for(l in 1:mm){D[[l]][,idx2]=D[[l]][,idx2]-D[[l]][,idx1]}
	### End of matrix of derivatives D
	
	### Begin calculation of V
	if(assoc.type=="corr")
	{
		# corstr=corstr
		rho.est1=rho.weight(Y1=Y1[[1]],mu=mu[[1]],corstr=corstr,W.rho=W.rho,data=data)	
		rho.est2=rho.h(Y1=Y1,mu=mu,corstr=corstr,D.p=D.p,W.rho=W.rho,data=data)
		rho.est=rho.est1+rho.est2
		if(any(abs(rho.est)>1)) {rho.est=NA}
		Vinv=gencov.corr.drgee(mu=mu,rho.est=rho.est,W=W,data=data)
	}else
	if(assoc.type=="odds")
	{
		Vinv=gencov.odds.drgee(mu=mu,LORterm=LORterm,W=W,data=data)
	}
	### End calculation of V
	
	est.ant=est
	###
	DVD.aux=matrix(0,n.par,n.par)
	for(l in 1:mm){DVD.aux=DVD.aux+D[[l]]%*%Vinv[[l]]%*%(D.p[,l]*t(D[[l]]))}
	DVD.inv=solve(DVD.aux)
	
	S.aux=matrix(0,n.par,1)
	for(l in 1:mm){S.aux=S.aux+D[[l]]%*%Vinv[[l]]%*%((Y1[[l]]-mu[[l]])*D.p[,l])}
	est=est+DVD.inv%*%(S.aux)
	diffe=max(abs((est-est.ant)/(est+1.e-6)))
	k=k+1
calpha=cbind(est[1:ncatm1])
cbeta=cbind(est[-(1:ncatm1)])
}
est=as.numeric(est)


#Calculation of Asymptotic Variance!
S.gamma=as.matrix(S.gamma)
#############
bread=DVD.inv;S.betas=matrix(NA,n,n.par)
for(i in 1:n)
{
	a=which(index2==i)
	S.aux.i=matrix(0,n.par,1)
	for(l in 1:mm){S.aux.i=S.aux.i+D[[l]][,a]%*%Vinv[[l]][a,a]%*%((Y1[[l]][a]-mu[[l]][a])*D.p[,l][a])}
	S.betas[i,]=S.aux.i
}
G=matrix(NA,n,n.par)
for(i in 1:n){G[i,]=S.betas[i,]+crossprod(S.betas,S.psi)%*%solve(crossprod(S.psi))%*%S.psi[i,]+
crossprod(S.betas,S.gamma)%*%solve(crossprod(S.gamma))%*%S.gamma[i,]}
std=sqrt(diag(bread%*%crossprod(G)%*%bread))
#
# cat("drgee",":",k,"\n")
names(est)=names(std)=c("beta01","beta02","X","Z")
if(assoc.type=="odds"){return(list(est=est,std=std,k=k,odds.est=odds.est))}else
if(assoc.type=="corr"){return(list(est=est,std=std,k=k,rho.est=rho.est))}
}
